# Smart Device Template

Repository and documentation for the Smart Device Template (SDT).

**Version 4.0**

The Smart Device Template is available under the 3-Clause BSD License. Read the [LICENSE](LICENSE) in this repository, or refer to  [https://opensource.org/licenses/BSD-3-Clause](https://opensource.org/licenses/BSD-3-Clause).

Any contributions made to the Smart Device Template format must comply with the aforementioned license. Models defined by using the Smart Device Template can be published under different licenses.

## Quick Introduction

![](SDT/schema4.0/docs/images/SDT_simplified.png)

The Smart Device Template (SDT) is a template method which is used to model the capabilities, actions and events of connected devices. The intent of the SDT is to be able to model any type of connected device using a well accepted and standardised format. The main application of SDT is to enable a uniformly structured Application Programmer's Interface (API) for applications that need to interact with connected devices. Usually, these applications would communicate to devices using an abstraction or service layer, or cloud platform as an intermediary logic. This layer usually "hides" the technology-specific, native language format of devices of different technology type from the applications.

[Read the full Introduction.](SDT/schema4.0/docs/Introduction.md)

## Quick Links
- [UML Diagrams of the SDT 4.0](SDT/schema4.0/docs/UML%20Diagram.md) ([Umlet source](SDT/schema4.0/docs/SDT_UML.uxf)) : These UML diagram describes the various components of the SDT and their relations.
- ['domain.xsd' Version 4.0](SDT/schema4.0/src/domain.xsd) : This is the XSD schema file that defines the SDT XML Schema.


## Documentation

You can find further Information here:

- [Introduction to the SDT](SDT/schema4.0/docs/Introduction.md)
- [SDT Components](SDT/schema4.0/docs/SDT_Components.md)
- [JSON Serialization](SDT/schema4.0/docs/SDT_JSON.md)
- [Examples](SDT/schema4.0/docs/Examples.md) 
- [SDT Build System](SDT/schema4.0/docs/SDT%20Build%20System.md)

## Further Readings
- [Links & References](SDT/schema4.0/docs/Links.md)
- [FAQ](SDT/schema4.0/docs/FAQ.md)
- [Changelog](SDT/schema4.0/docs/Changelog.md)
- [SDT Build System Components and Licenses](SDT/schema4.0/docs/SDT%20Build%20System%20Components%20and%20Licenses.md)
- [LICENSE](LICENSE)


